#!/usr/bin/perl -w

# GUI for LinuxSMS (by zOmbie) 
# Version 0.11

# Copyright (C) 2003 Felix Knecht (mail at felixknecht dot de)
# Copyright (C) Kali (kali@kalimotxo.net)
# Copyright (C) Igor Castang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


use strict;

use Tk;
use Tk::Dialog;
my $HOME = $ENV{HOME};


my $OS_PREFIX = "";
# Check if the script is running on Windows and set prefix (to make windows calls work)
$OS_PREFIX = "perl " if ($^O =~ m/Win/o);

# on linux we use ' in commands to prevent shell parsing; in windows we need to use "
my $OS_SIGN = "'";
$OS_SIGN = "\"" if ($^O =~ m/Win/o);

my $win= MainWindow->new();
$win->configure(-title=>"XLinuxSMS",-background=>"red");
$win->minsize("250","100");
my $menu=$win->Frame(-relief=>'groove',-borderwidth=>3,-background=>'blue',)->pack('-side'=>'top',-fill=>'x');

my $topf=$win->Frame()->pack(-side=>'top',-fill=>'x');
my $number_l=$topf->Label(-text=>'Mobile-Nr.')->pack();
my $number_f=$topf->Entry(-width=>12,-background=>'white')->pack(-pady=>1);
my $prefix_l=$topf->Label(-text=>'Prefix')->pack();
my $prefix_f=$topf->Entry(-width=>3,-background=>'white')->pack(-pady=>1);
my $server_l=$topf->Label(-text=>'Server')->pack();
my $server_f=$topf->Entry(-width=>10,-background=>'white')->pack(-pady=>1);
my $message_l=$topf->Label(-text=>'Message')->pack();
my $message_f=$topf->Entry(-width=>30,-background=>'white')->pack(-pady=>1);
$message_f->bind("<KeyRelease>" =>sub{textUpdated()});
my $messageLength_l=$topf->Label(-text=>'0')->pack();
my $send_b=$topf->Button(-text=>'Send',-command=>\&send)->pack();

#list name in adress book
my @name=&list_addressbook();
my $num_lab=$menu->Label(-text=>'Addressbook')->pack();
my $number_i=$menu->Listbox(-height=>0)->pack();
   $number_i->insert('end',@name);
   $number_i->bind('<Button-1>',sub { 	$number_f->delete(0,'end');
					$prefix_f->delete(0,'end');
					$server_f->delete(0,'end'); 
					my ($n, $p, $s) = &addressbook($name[$number_i->curselection]);
					$number_f->insert(0,$n);
				      	$prefix_f->insert(0,$p);
					$server_f->insert(0,$s);
				    });


#list iserver name 

my @server=&list_server();
my $ser_lab=$menu->Label(-text=>'Known Server')->pack();
my $server_i=$menu->Listbox(-height=>0)->pack();
   $server_i->insert('end',@server);
   $server_i->bind('<Button-1>',sub { $server_f->delete(0,'end'); $server_f->insert(0,$server[$server_i->curselection])});


#

MainLoop();


sub list_addressbook() {
    my $ADDRESSBOOK = $HOME."/.linuxsms/addressbook";
    my ($LINE, $N);
    open (ADDRESSBOOK, $ADDRESSBOOK) or die "error\!, can\'t open $ADDRESSBOOK\n";
    while ($LINE = <ADDRESSBOOK>) {
        if (($LINE !~ /^$/) && ($LINE !~ /^#/)) {
            if ($LINE =~ /^(.*?)\:(\d*?)\:(\d*?)\:/) {
	     push(@name,$1);
            }
        }
    }
    close (ADDRESSBOOK);
    return(@name);
}

sub list_server() {
    open(LINSMS,$OS_PREFIX . "linuxsms -server|");
   while (my $LINE = <LINSMS>) {
        if ($LINE !~ /register/) {
#            if ($LINE =~ /^- (\[\*\]|\[-\]) : (.*?\w*):\s(.*):(.*):(.*):(.*)$/) {
             if ($LINE =~ /^- (\[\*\]|\[-\])\s:\s*?(\w*?)\s*?:\s(.*):(.*):(.*):(.*)$/) {
	     #print "$2\n";
	     push(@server,$2);
	    }
        }
    }
    close (LINSMS);
    return(@server);
} 

sub send() {
my $msg=$message_f->get();
if (length $msg > 160)
{
	#print "Nachricht zu lang!\n";
	my $errorMsg = $win->Dialog (-text=>"Message too long");
	$errorMsg->Show();
	return 0;
}

if (length $server_f->get() <=0)
{
        my $errorMsg = $win->Dialog (-text=>"Please select a server");
        $errorMsg->Show();
        return 0;
}

if (length $number_f->get() <=0)
{
        my $errorMsg = $win->Dialog (-text=>"Please enter a mobile number");
        $errorMsg->Show();
        return 0;
}

if (length $prefix_f->get() <=0)
{
        my $errorMsg = $win->Dialog (-text=>"Please enter a country prefix");
        $errorMsg->Show();
        return 0;
}

if (length $msg <=0)
{
        my $errorMsg = $win->Dialog (-text=>"Please enter a message");
        $errorMsg->Show();
        return 0;
}


replaceOSSign(\$msg);

my $serv=$server_f->get();
my $numb=$number_f->get();
my $pref=$prefix_f->get();
my $cmd=$OS_PREFIX . "linuxsms -sms:$OS_SIGN$msg$OS_SIGN -number:$OS_SIGN$numb$OS_SIGN -prefix:$OS_SIGN$pref$OS_SIGN -server:$OS_SIGN$serv$OS_SIGN ";
print $cmd;
print(`$cmd`);
}


# this sub checks the strings for $OS_SIGN and replaces all of them with the counter sign
# otherwise the shell gets confused
# on linux: ' -> "
# on windows: " -> '

sub replaceOSSign()
{
	my $string = pop @_;
	
	($^O =~ m/Win/o) ? $$string =~ s/\"/\'/g : $$string =~ s/\'/\"/g;
	
	#print "\n" . $$string . "\n";
}




sub addressbook() {
    my $ADDRESSBOOK = $HOME."/.linuxsms/addressbook";
    my ($LINE, $add_Number, $add_Prefix, $add_Server);
    my $add_s;
    open (ADDRESSBOOK, $ADDRESSBOOK) or die "error\!, can\'t open $ADDRESSBOOK\n";
    while ($LINE = <ADDRESSBOOK>) {
        if (($LINE !~ /^$/) && ($LINE !~ /^#/)) {
	    if ($LINE =~ /^(.*?)\:(\d*?)\:(\d*?)\:(.*?)$/)  	#name:number:prefix:defaultserver
	    {	
                if ($_[0] eq $1) 
		{ 
			$add_Number = $3; 
			$add_Prefix = $2;
		
			foreach $add_s (@server)
			{
				if ($add_s eq $4)
				{
					$add_Server = $4;
					#print "Name: $1 Prefix: $2 Nummer: $3 Server: $4";
				}
				#else { print "$add_s not equal $4\n";}
			}
		}
		#print "Name: $1 Prefix: $2 Nummer: $3 Server: $4";
            }
        }
    }
    close (ADDRESSBOOK);
    if (! $add_Number) { die "error\!, name $_[0] was not found in $ADDRESSBOOK\n"; }
    return($add_Number,$add_Prefix,$add_Server);
}


sub textUpdated()
{

my $string = $message_f->get();
my $length = length $string;

#print ("$string has $length\n");
$messageLength_l->configure (-text=>$length);
}
